#ifndef ENEMY_H
#define ENEMY_H

#include <cpctelera.h>
#include "Actor.h"
#include "Cell.h"
#include "GameState.h"
#include "GameTypes.h"
#include "Object.h"
#include "Timer.h"
#include "sprites/EnemySprites.h"

#define ENEMY_WIDTH 4
#define ENEMY_HEIGHT 16

//#define ENEMY_TYPE_UP_DOWN 0
#define ENEMY_TYPE_ROBOT 1
//#define ENEMY_TYPE_WALL_HUGGER 2
#define ENEMY_TYPE_CHASER 3
#define ENEMY_TYPE_CHASER_LOW_RANGE 4

//todo tune with difficulty
#define ENEMY_STUN_TIME 250

typedef struct Enemy Enemy;

struct Enemy
{
	//actor properties
	Object object;	
	u8 backgroundSprite[64];
	u16 timer;
	u8 health;

	//enemy properties
	
	//u8 sourceCellX : 5;
	//u8 sourceCellY : 4;
	//u8 destinationCellY : 4;	
	u8 type : 4;
	u8 enemyNumber : 4; //8
	//u8 destinationCellX : 5;
	u8 cellX : 5;
	u8 destroyed : 1;
	u8 direction : 2; //8
	u8 cellXNext : 5;
	u8 speed : 2;
	u8 speedCount : 1; //8
	u8 cellY : 4;
	u8 cellYNext : 4; //8
	
	u8 redraw : 1;
	u8 stunned : 1;
};

//initalises the enemy data structure
void initEnemy(Enemy* enemy, u8 enemyNumber, u8 x, u8 y, u8 type);

//draws the enemy on screen
void drawEnemy(Enemy* enemy);

//general enemy logic for enemy behaviour
void logicEnemy(Enemy* enemy, Actor* playerActor, u8* playerCollisionIndicator, u8* playerCollisionFlickerCount, u8* playerInventory);

//determines enemy for enemy type ENEMY_TYPE_WALL_HUGGER
//void moveEnemy(Enemy* enemy);

//determines enemy for enemy type ENEMY_TYPE_CHASER_LOW_RANGE and ENEMY_TYPE_CHASER
void eraticEnemy(Enemy* enemy, Object* playerObject);

//updates the cell/position that the enemy resides in the map
void updateEnemyCellPosition(Enemy* enemy);

//cleanup an enemy after it has been killed
void killEnemy(Enemy* enemy);

#endif