#ifndef KEYS_H
#define KEYS_H

#include <cpctelera.h>
#include "GameTypes.h"

typedef struct Keys Keys;

struct Keys
{
    cpct_keyID left;
    cpct_keyID right;
    cpct_keyID up;
    cpct_keyID down;
    cpct_keyID shoot;
    cpct_keyID exit;
	cpct_keyID objective;
	cpct_keyID weapon;
    u8 leftIsDown : 1;
    u8 rightIsDown : 1;
    u8 upIsDown : 1;
    u8 downIsDown : 1;
    u8 shootIsDown : 1;
	u8 weaponIsDown : 1;
};

//sets the default keys when the game first loads
void setupDefaultKeys();

//initialises IsDown values so that no keys are pressed at the start of the game
void initKeys();

extern Keys gameControls;

#endif