#ifndef MENU_H
#define MENU_H

#include <cpctelera.h>
#include "Difficulty.h"
#include "Game.h"
#include "GameState.h"
#include "Keys.h"
#include "Palette.h"
#include "Player.h"
#include "Text.h"

void runMenu();

void drawMenu();

void drawIndicator();

//let the user choose new keyboard/joystick controls for the game
void rebindControls();

//get key function for rebind/redefine key controls by ranaldo
cpct_keyID getKey();

//switch between a GT64 friendly palette and a more colourful palette
void colourMode();

//initialise high score values
void initScores();

//display current high scores on the screen
void displayHighScores();

//update the high scores if the player has been successful
void updateHighScores();

//choose the difficulty option to play the game at
void chooseDifficulty();

//displays either victorious or game over depending on if the user completes the game or not
void displayEndScreen();

//display the loading screen to tell the user to wait/what to do
void loadingScreen();

#endif